/*
*	New C++ File starts here.
*	This file should be named rk4n.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "rk4n.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : rk4Format
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
int rk4Format(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case RK4_HALT_TYPE:
		((RK4_HALT *) buffer)->update(cms);
		break;
	case RK4_INIT_TYPE:
		((RK4_INIT *) buffer)->update(cms);
		break;
	case RK4_RUN_TYPE:
		((RK4_RUN *) buffer)->update(cms);
		break;
	case RK4_STATUS_TYPE:
		((RK4_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *rk4_symbol_lookup(int type)
{
	switch(type)
	{
	case RK4_HALT_TYPE:
		return "RK4_HALT";
	case RK4_INIT_TYPE:
		return "RK4_INIT";
	case RK4_RUN_TYPE:
		return "RK4_RUN";
	case RK4_STATUS_TYPE:
		return "RK4_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for RK4_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
void RK4_STATUS::update(CMS *cms)
{
	cms->update(current_time);
	cms->update(plant_state,4);
	cms->update(ctrl_input,4);

}


/*
*	NML/CMS Update function for RK4_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
void RK4_RUN::update(CMS *cms)
{
	cms->update(num_sim_per_cycle);
	cms->update(initial_time);
	cms->update(final_time);
	cms->update(initial_state,4);

}


/*
*	NML/CMS Update function for RK4_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
void RK4_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for RK4_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
void RK4_INIT::update(CMS *cms)
{
	cms->update(cycle_time);

}

/*
*	Constructor for RK4_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
RK4_STATUS::RK4_STATUS()
	: RCS_STAT_MSG(RK4_STATUS_TYPE,sizeof(RK4_STATUS))
{
	current_time = (double) 0;
	/*
	* The array plant_state should be initialized here.
	*/

	/*
	* The array ctrl_input should be initialized here.
	*/


}

/*
*	Constructor for RK4_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
RK4_RUN::RK4_RUN()
	: RCS_CMD_MSG(RK4_RUN_TYPE,sizeof(RK4_RUN))
{
	num_sim_per_cycle = (int) 0;
	initial_time = (double) 0;
	final_time = (double) 0;
	/*
	* The array initial_state should be initialized here.
	*/


}

/*
*	Constructor for RK4_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
RK4_HALT::RK4_HALT()
	: RCS_CMD_MSG(RK4_HALT_TYPE,sizeof(RK4_HALT))
{

}

/*
*	Constructor for RK4_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 19:12:43 EDT 1999
*/
RK4_INIT::RK4_INIT()
	: RCS_CMD_MSG(RK4_INIT_TYPE,sizeof(RK4_INIT))
{
	cycle_time = (double) 0;

}

