/*
rk4n.hh

This C++ header file defines the NML Messages used for command and status by RK4_MODULE
Template Version 1.1

MODIFICATIONS:
12-Sep-99	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef RK4N_HH
#define RK4N_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

#define PLANT_ORDER 4
#define CTRL_ORDER 4

// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define RK4_STATUS_TYPE 1000
#define RK4_HALT_TYPE 1001
#define RK4_INIT_TYPE 1002
#define RK4_RUN_TYPE 1003
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class RK4_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	RK4_STATUS();

	// Constructor used by derived classes
	RK4_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double current_time;
  double plant_state[PLANT_ORDER];
  double ctrl_input[CTRL_ORDER];

};

// Command Classes

class RK4_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	RK4_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RK4_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	RK4_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double cycle_time;

};

class RK4_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	RK4_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int  num_sim_per_cycle;
  double initial_time;
  double final_time;
  double initial_state[PLANT_ORDER];

};

// Declare NML format function
extern int rk4Format(NMLTYPE, void *, CMS *);

#endif 	// RK4N_HH
