/*
	rk4_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		RK4_MODULE

	MODIFICATIONS:
	12-Sep-99	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rk4.hh"	// definition of RK4_MODULE

// flag signifying main loop is to terminate
int rk4_module_done = 0;

//signal handler for ^C
extern "C" void rk4_module_quit(int sig);
void rk4_module_quit(int sig)
{
	rk4_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int rk4_module_run();

int rk4_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	RK4_MODULE *rk4 = new RK4_MODULE();

	// set the SIGINT handler
	signal(SIGINT, rk4_module_quit);

	// enter main loop
	while(!rk4_module_done)
	{
		rk4->controller();

		timer->wait();
	}

	// Delete Modules
	delete rk4;

	// Delete Timer
	delete timer;
}

